///////////////////////////////////////
//  copyright Alexandre Chouvellon 2009
//  Source libre de droit
///////////////////////////////////////
#ifndef CHAINEDLIST_FWD_H
#define CHAINEDLIST_FWD_H
#include "structure.fwd.h"

struct ChainedList;
struct MyFifoList;
struct Element;
typedef struct ChainedList ChainedList;
typedef struct MyFifoList MyFifoList;
typedef struct Element Element;

//va insrer (tri cls croissantes) et allouer l'lment compos de board et construit grace  action
//findElement OUTPUT: l'lment insr ou deja insr
//added OUTPUT: indique si l'lment a t ajout
//retourne la nouvelle tte de la liste  
ChainedList * pushMe(ChainedList * head, Board * board, Action action,  struct Element ** findElement, char * added);


long long buildPrimaryKey(Board * board);
ChainedList * pop(MyFifoList * fifo);
void pushToEnd(MyFifoList ** fifo, struct Element *  elem);  
struct Element * allocElement();
void freeChainedList(ChainedList * list);
void freeFifo(MyFifoList * fifo);
Element * getPreviousElement(Element * elem);
Action getActionDone(Element * elem);
Board * getBoard(Element * elem);
void setActionDone(Element * elem, Action a );
void setPreviousElement(Element * elem, Element * d);
Location * getBlank1(Element * e);
Location * getBlank2(Element * e);
Element * getElement(ChainedList * a);
#endif 
