///////////////////////////////////////
//  copyright Alexandre Chouvellon 2009
//  Source libre de droit
///////////////////////////////////////

#ifndef DEBUG_DONKEY_H
#define DEBUG_DONKEY_H
#include <stdio.h>
#include "structure.fwd.h"
#include "list.fwd.h"

//construit une board  partir d'un fichier
int  loadFile(FILE * file, Board * board);

//vrifie la validit d'un plateau, cette fonction peut servir de debug
int checkConsistancy(Board *board);

//construction de la solution (fonction rcursive)
//deep: nombre de coups restants
//elem: l'element  partir duquel revenir en arrire (jusqu' l'tat initial
int explainSolution(Element *elem, int deep);
#endif
