///////////////////////////////////////
//  copyright Alexandre Chouvellon 2009
//  Source libre de droit
///////////////////////////////////////
#ifndef ANALYSIS_H
#define ANALYSIS_H

#include "donkey.h"
#include "move.h"
#include "list.fwd.h"
#include "structure.fwd.h"

//fonction permettant la recherche en largeur grce  une FIFO 
int analyseStateFIFO();

//fonction qui va construire le nouvel etat de notre jeu
//board : l'etat courant du plateau
//action : la derniere action ralise   , -1 si c'est l'tat initial
//blank1 : localisation d'un vide
//blank2:localisation de l'autre vide
//previous state: l'etat prcdent, NULL si initial, sert uniquement pour l'impression de la solution   
int updateAfterMove(Board * board, Action action, Location * blank1, Location * blank2, Element * previousState);

//libre la mmoire des sous liste de l'historique
void freeAllChainedLists();


#endif
